

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>d2o.learn.nn.datasets &mdash; d2o Python Library 1.0 documentation</title>
  

  
  

  

  
  
    

  

  
  
    <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  

  

  
    <link rel="top" title="d2o Python Library 1.0 documentation" href="../../../../index.html"/>
        <link rel="up" title="Module code" href="../../../index.html"/> 

  
  <script src="../../../../_static/js/modernizr.min.js"></script>

</head>

<body class="wy-body-for-nav" role="document">

  <div class="wy-grid-for-nav">

    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search">
          

          
            <a href="../../../../index.html" class="icon icon-home"> d2o Python Library
          

          
          </a>

          
            
            
              <div class="version">
                1.0
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
                <ul class="simple">
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" role="navigation" aria-label="top navigation">
        <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
        <a href="../../../../index.html">d2o Python Library</a>
      </nav>


      
      <div class="wy-nav-content">
        <div class="rst-content">
          





<div role="navigation" aria-label="breadcrumbs navigation">
  <ul class="wy-breadcrumbs">
    <li><a href="../../../../index.html">Docs</a> &raquo;</li>
      
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      
    <li>d2o.learn.nn.datasets</li>
      <li class="wy-breadcrumbs-aside">
        
          
        
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  <h1>Source code for d2o.learn.nn.datasets</h1><div class="highlight"><pre>
<span></span><span class="c1"># -*- encoding: utf-8 -*-</span>
<span class="c1">#</span>
<span class="c1"># Copyright (c) 2016 Chronos AS</span>
<span class="c1">#</span>
<span class="c1"># Authors: Fredrik Stormo, Stefan Remman</span>
<span class="c1"># Contact: kjetil.karlsen@chronosit.no</span>

<span class="kn">import</span> <span class="nn">numpy</span> <span class="kn">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">d2o.utils</span> <span class="kn">import</span> <span class="n">logger</span> <span class="k">as</span> <span class="n">log</span>

<span class="kn">from</span> <span class="nn">sklearn.preprocessing</span> <span class="kn">import</span> <span class="n">MinMaxScaler</span><span class="p">,</span> <span class="n">StandardScaler</span>

<div class="viewcode-block" id="Dataset"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset">[docs]</a><span class="k">class</span> <span class="nc">Dataset</span><span class="p">:</span>
  <span class="sd">&quot;&quot;&quot; Dataset designed for use in Neural Networks.</span>
<span class="sd">  Splits into training and target sets and contains methods for</span>
<span class="sd">  scaling input to transfer function ranges.&quot;&quot;&quot;</span>
  <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">df</span><span class="p">,</span> <span class="n">input_mask</span><span class="p">,</span> <span class="n">target_mask</span><span class="p">,</span> <span class="n">training_percentage</span><span class="o">=</span><span class="mf">0.8</span><span class="p">,</span> <span class="n">name</span><span class="o">=</span><span class="s2">&quot;Unnamed&quot;</span><span class="p">):</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">df</span> <span class="o">=</span> <span class="n">df</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">input_mask</span> <span class="o">=</span> <span class="n">input_mask</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">target_mask</span> <span class="o">=</span> <span class="n">target_mask</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span>

    <span class="n">earliest_index</span> <span class="o">=</span> <span class="nb">abs</span><span class="p">(</span><span class="nb">min</span><span class="p">([</span><span class="n">x</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="bp">self</span><span class="o">.</span><span class="n">input_mask</span><span class="o">.</span><span class="n">layout</span><span class="p">()]))</span>

    <span class="n">inputs</span> <span class="o">=</span> <span class="p">[]</span> <span class="c1"># (input, target)</span>
    <span class="n">targets</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">for</span> <span class="n">ix</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">earliest_index</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">)):</span>
      <span class="k">try</span><span class="p">:</span>
        <span class="n">input_vector</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">input_mask</span><span class="o">.</span><span class="n">apply_serialize</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">,</span> <span class="n">ix</span><span class="p">)[</span><span class="mi">1</span><span class="p">]</span>
        <span class="n">target_vector</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">target_mask</span><span class="o">.</span><span class="n">apply_serialize</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">df</span><span class="p">,</span> <span class="n">ix</span><span class="p">)[</span><span class="mi">1</span><span class="p">]</span>

        <span class="n">inputs</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">input_vector</span><span class="p">)</span>
        <span class="n">targets</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">target_vector</span><span class="p">)</span>
      <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
        <span class="k">continue</span>
      <span class="k">except</span><span class="p">:</span>
        <span class="k">raise</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">input_scaler</span> <span class="o">=</span> <span class="n">MinMaxScaler</span><span class="p">([</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">])</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">output_scaler</span> <span class="o">=</span> <span class="n">MinMaxScaler</span><span class="p">([</span><span class="o">-</span><span class="mi">1</span><span class="p">,</span> <span class="mi">1</span><span class="p">])</span>

    <span class="c1"># self.input_scaler = StandardScaler()</span>
    <span class="c1"># self.output_scaler = StandardScaler()</span>

    <span class="n">inputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">input_scaler</span><span class="o">.</span><span class="n">fit_transform</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">inputs</span><span class="p">))</span>
    <span class="n">targets</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">output_scaler</span><span class="o">.</span><span class="n">fit_transform</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">targets</span><span class="p">))</span>

    <span class="n">data_set</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="nb">list</span><span class="p">(</span><span class="n">x</span><span class="p">)</span> <span class="k">for</span> <span class="n">x</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">inputs</span><span class="o">.</span><span class="n">tolist</span><span class="p">(),</span> <span class="n">targets</span><span class="o">.</span><span class="n">tolist</span><span class="p">())])</span>
    <span class="n">training_size</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">data_set</span><span class="p">)</span><span class="o">*</span><span class="n">training_percentage</span><span class="p">)</span>

    <span class="bp">self</span><span class="o">.</span><span class="n">training_set</span> <span class="o">=</span> <span class="n">data_set</span><span class="p">[:</span><span class="n">training_size</span><span class="p">]</span>
    <span class="bp">self</span><span class="o">.</span><span class="n">test_set</span> <span class="o">=</span> <span class="n">data_set</span><span class="p">[</span><span class="n">training_size</span><span class="p">:]</span>

<div class="viewcode-block" id="Dataset.training_inputs"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset.training_inputs">[docs]</a>  <span class="k">def</span> <span class="nf">training_inputs</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">limit</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">training_set</span><span class="p">[:,</span><span class="mi">0</span><span class="p">][:</span><span class="n">limit</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">ret</span><span class="o">.</span><span class="n">tolist</span><span class="p">())</span></div>

<div class="viewcode-block" id="Dataset.training_targets"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset.training_targets">[docs]</a>  <span class="k">def</span> <span class="nf">training_targets</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">limit</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">training_set</span><span class="p">[:,</span><span class="mi">1</span><span class="p">][:</span><span class="n">limit</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">ret</span><span class="o">.</span><span class="n">tolist</span><span class="p">())</span></div>

<div class="viewcode-block" id="Dataset.test_inputs"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset.test_inputs">[docs]</a>  <span class="k">def</span> <span class="nf">test_inputs</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">limit</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test_set</span><span class="p">[:,</span><span class="mi">0</span><span class="p">][:</span><span class="n">limit</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">ret</span><span class="o">.</span><span class="n">tolist</span><span class="p">())</span></div>

<div class="viewcode-block" id="Dataset.test_targets"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset.test_targets">[docs]</a>  <span class="k">def</span> <span class="nf">test_targets</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">limit</span><span class="o">=</span><span class="bp">None</span><span class="p">):</span>
    <span class="n">ret</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test_set</span><span class="p">[:,</span><span class="mi">1</span><span class="p">][:</span><span class="n">limit</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">ret</span><span class="o">.</span><span class="n">tolist</span><span class="p">())</span></div>

<div class="viewcode-block" id="Dataset.input_size"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset.input_size">[docs]</a>  <span class="k">def</span> <span class="nf">input_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">input_mask</span><span class="p">)</span></div>

<div class="viewcode-block" id="Dataset.output_size"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset.output_size">[docs]</a>  <span class="k">def</span> <span class="nf">output_size</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="k">return</span> <span class="nb">len</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">target_mask</span><span class="p">)</span></div>

<div class="viewcode-block" id="Dataset.validate"><a class="viewcode-back" href="../../../../d2o.learn.nn.html#d2o.learn.nn.datasets.Dataset.validate">[docs]</a>  <span class="k">def</span> <span class="nf">validate</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
    <span class="n">num_equal_inputs</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="n">__test_inputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test_inputs</span><span class="p">()</span>
    <span class="n">__test_targets</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test_targets</span><span class="p">()</span>
    <span class="n">__training_inputs</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">training_inputs</span><span class="p">()</span>
    <span class="n">__training_targets</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">training_targets</span><span class="p">()</span>

    <span class="k">for</span> <span class="n">itest</span><span class="p">,</span><span class="n">test_input</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">__test_inputs</span><span class="p">):</span>
      <span class="k">for</span> <span class="n">itrain</span><span class="p">,</span><span class="n">training_input</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">__training_inputs</span><span class="p">):</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array_equal</span><span class="p">(</span><span class="n">test_input</span><span class="p">,</span> <span class="n">training_input</span><span class="p">)):</span>
          <span class="n">num_equal_inputs</span> <span class="o">+=</span> <span class="mi">1</span>

    <span class="n">num_equal_targets</span> <span class="o">=</span> <span class="mi">0</span>
    <span class="k">for</span> <span class="n">itest</span><span class="p">,</span><span class="n">test_target</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">__test_targets</span><span class="p">):</span>
      <span class="k">for</span> <span class="n">itrain</span><span class="p">,</span><span class="n">training_target</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">__training_targets</span><span class="p">):</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">array_equal</span><span class="p">(</span><span class="n">test_input</span><span class="p">,</span> <span class="n">training_input</span><span class="p">)):</span>
          <span class="n">num_equal_targets</span> <span class="o">+=</span> <span class="mi">1</span>

    <span class="k">if</span> <span class="p">(</span><span class="n">num_equal_inputs</span> <span class="o">==</span> <span class="n">num_equal_targets</span> <span class="o">==</span> <span class="mi">0</span><span class="p">):</span>
      <span class="k">return</span> <span class="bp">True</span>
    <span class="k">else</span><span class="p">:</span>
      <span class="n">log</span><span class="o">.</span><span class="n">warn</span><span class="p">(</span><span class="s2">&quot;Number of equal samples (</span><span class="si">%s</span><span class="s2">/</span><span class="si">%s</span><span class="s2">)&quot;</span> <span class="o">%</span> <span class="p">(</span><span class="n">num_equal_inputs</span><span class="p">,</span> <span class="n">num_equal_targets</span><span class="p">))</span>
      <span class="k">return</span> <span class="bp">False</span></div></div>

</pre></div>

           </div>
          </div>
          <footer>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2016, Chronos AS.

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/snide/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  

    <script type="text/javascript">
        var DOCUMENTATION_OPTIONS = {
            URL_ROOT:'../../../../',
            VERSION:'1.0',
            COLLAPSE_INDEX:false,
            FILE_SUFFIX:'.html',
            HAS_SOURCE:  true
        };
    </script>
      <script type="text/javascript" src="../../../../_static/jquery.js"></script>
      <script type="text/javascript" src="../../../../_static/underscore.js"></script>
      <script type="text/javascript" src="../../../../_static/doctools.js"></script>
      <script type="text/javascript" src="https://cdn.mathjax.org/mathjax/latest/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>

  

  
  
    <script type="text/javascript" src="../../../../_static/js/theme.js"></script>
  

  
  
  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.StickyNav.enable();
      });
  </script>
   

</body>
</html>